from zope.interface import implements
from Products.Five.browser import BrowserView
from Products.Five.formlib import formbase
from tecnoteca.plonecmdbuild.config import *
from tecnoteca.plonecmdbuild.interfaces.config import ITTPloneCMDBuildConfig
from Products.CMFCore.utils import getToolByName
from zope.i18nmessageid import MessageFactory
from zope.formlib import form
from zope.interface import implements
from zope.schema.fieldproperty import FieldProperty
from OFS.SimpleItem import SimpleItem
from zope.component import getUtility

_ = MessageFactory('tecnoteca.plonecmdbuild')

class TTPloneCMDBuildConfig(BrowserView):

    implements(ITTPloneCMDBuildConfig)

    def __init__(self, context, request):
        """ init view """
        self.context = context
        self.request = request
        portal_props = getToolByName(context, 'portal_properties')
        self.properties = getattr(portal_props, PROPERTY_SHEET, None)

    @property
    def webservice_url(self):
        if self.properties is None:
            return 'undefined'
        return getattr(self.properties, PROPERTY_WEBSERVICE_URL, None)
    
    @property
    def webservice_username(self):
        if self.properties is None:
            return 'undefined'
        return getattr(self.properties, PROPERTY_WEBSERVICE_USERNAME, None)

    @property
    def webservice_password(self):
        if self.properties is None:
            return 'undefined'
        return getattr(self.properties, PROPERTY_WEBSERVICE_PASSWORD, None)

    @property
    def dms_lookup(self):
        if self.properties is None:
            return 'undefined'
        return getattr(self.properties, PROPERTY_DMS_LOOKUP, None)
    
    @property
    def results_per_page(self):
        if self.properties is None:
            return 'undefined'
        return getattr(self.properties, PROPERTY_RESULTS_PER_PAGE, None)