from zope.interface import Interface
from zope.component import adapts
from zope.interface import implements
from zope.formlib.form import FormFields

from zope.i18nmessageid import MessageFactory

from zope.schema import Tuple
from zope.schema import TextLine
from zope.schema import Int
from zope.schema import Bool


from zope.schema.vocabulary import SimpleTerm, SimpleVocabulary

from plone.app.controlpanel.form import ControlPanelForm

from Products.CMFCore.utils import getToolByName
from Products.CMFDefault.formlib.schema import SchemaAdapterBase
from Products.CMFPlone.interfaces import IPloneSiteRoot

from tecnoteca.plonecmdbuild.config import *


_ = MessageFactory('tecnoteca.plonecmdbuild')


class IPloneCMDBuildSchema(Interface):    
            
    webservice_url = TextLine(
        title=_(u'Webservice URL'),
        description=_(u"Webservice URL desc"),
        required=True)
    
    webservice_username = TextLine(
        title=_(u'Webservice username'),
        description=_(u"Webservice username desc"),
        required=True)
    
    webservice_password = TextLine(
        title=_(u'Webservice password'),
        description=_(u"Webservice password desc"),
        required=True)
    
    dms_lookup = TextLine(
        title=_(u'Dms lookup'),
        description=_(u"Dms lookup desc"),
        required=True)
    
    results_per_page = Int(
        title=_(u'Results per page'),
        description=_(u"Results per page desc"),
        required=True)
            

class PloneCMDBuildControlPanelAdapter(SchemaAdapterBase):

    adapts(IPloneSiteRoot)
    implements(IPloneCMDBuildSchema)

    def __init__(self, context):
        super(PloneCMDBuildControlPanelAdapter, self).__init__(context)
        properties = getToolByName(context, 'portal_properties')
        self.context = properties.ttplonecmdbuild_properties


    def get_webservice_url(self):
        return getattr(self.context, PROPERTY_WEBSERVICE_URL, "")
    def set_webservice_url(self, value):
        self.context._updateProperty(PROPERTY_WEBSERVICE_URL, value)
    webservice_url = property(get_webservice_url, set_webservice_url)
    
    
    def get_webservice_username(self):
        return getattr(self.context, PROPERTY_WEBSERVICE_USERNAME, "")
    def set_webservice_username(self, value):
        self.context._updateProperty(PROPERTY_WEBSERVICE_USERNAME, value)
    webservice_username = property(get_webservice_username, set_webservice_username)


    def get_webservice_password(self):
        return getattr(self.context, PROPERTY_WEBSERVICE_PASSWORD, "")
    def set_webservice_password(self, value):
        self.context._updateProperty(PROPERTY_WEBSERVICE_PASSWORD, value)
    webservice_password = property(get_webservice_password, set_webservice_password)   
    
    
    def get_dms_lookup(self):
        return getattr(self.context, PROPERTY_DMS_LOOKUP, '')
    def set_dms_lookup(self, value):
        self.context._updateProperty(PROPERTY_DMS_LOOKUP, value)
    dms_lookup = property(get_dms_lookup, set_dms_lookup)
    
    
    def get_results_per_page(self):
        return getattr(self.context, PROPERTY_RESULTS_PER_PAGE, '')
    def set_results_per_page(self, value):
        self.context._updateProperty(PROPERTY_RESULTS_PER_PAGE, value)
    results_per_page = property(get_results_per_page, set_results_per_page)
    
        

class PloneCMDBuildControlPanel(ControlPanelForm):
    form_fields = FormFields(IPloneCMDBuildSchema)
    label = _("Product settings")
    description = None
    form_name = _("Parameters configuration")
