import logging
import logging.handlers
from tecnoteca.plonecmdbuild.config import PROJECTNAME
from tecnoteca.plonecmdbuild.ws.WSProperties import WSProperties
import os

instance_home = os.environ.get("INSTANCE_HOME")
logfile = os.path.join(instance_home,"log","plonecmdbuild.log")

# Set up a specific logger with our desired output level
logger = logging.getLogger(PROJECTNAME)
logger.setLevel(logging.DEBUG)

# Add the log message handler to the logger
maxBytes = 2097152 # 2 MB
handler = logging.handlers.RotatingFileHandler(logfile, maxBytes=maxBytes, backupCount=5)
formatter = logging.Formatter("%(asctime)s - %(name)s - %(levelname)s - %(message)s")
handler.setFormatter(formatter)
logger.addHandler(handler)