"""Definition of the TTPloneCMDBuild content type
"""

from zope.interface import implements

from Products.Archetypes import atapi
from Products.ATContentTypes.content import base
from Products.ATContentTypes.content import schemata

from tecnoteca.plonecmdbuild import plonecmdbuildMessageFactory as _
from tecnoteca.plonecmdbuild.interfaces import ITTPloneCMDBuild
from tecnoteca.plonecmdbuild.config import PROJECTNAME

from tecnoteca.plonecmdbuild.ws.CMDBuildWebservice import CMDBuildWebservice
from tecnoteca.plonecmdbuild.ws.WSConst import WSConst as const

from ZTUtils.Zope import make_query
from zExceptions import Redirect

import traceback

TTPloneCMDBuildSchema = schemata.ATContentTypeSchema.copy() + atapi.Schema((

    # -*- Your Archetypes field definitions here ... -*-

))

# Set storage on fields copied from ATContentTypeSchema, making sure
# they work well with the python bridge properties.

TTPloneCMDBuildSchema['title'].storage = atapi.AnnotationStorage()
TTPloneCMDBuildSchema['description'].storage = atapi.AnnotationStorage()

schemata.finalizeATCTSchema(TTPloneCMDBuildSchema, moveDiscussion=False)


class TTPloneCMDBuild(base.ATCTContent):
    """Tecnoteca Plone CMDBuild""" 
    implements(ITTPloneCMDBuild)

    meta_type = "TTPloneCMDBuild"
    schema = TTPloneCMDBuildSchema

    title = atapi.ATFieldProperty('title')
    description = atapi.ATFieldProperty('description')

    # -*- Your ATSchema to Python Property Bridges Here ... -*-
    
    def getWS(self):
        return CMDBuildWebservice(self)
    
    def raiseRedirect(self, className):
        """ 
        Utility method to launch Redirect exceptions.
        This method/exception is used to force redirect after a ws call.
        """
        url = '%s/cardList?%s' % (self.absolute_url() , make_query({const.CLASSNAME:className}))
        raise Redirect, (url)
        
    
atapi.registerType(TTPloneCMDBuild, PROJECTNAME)
