## Python Script
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
from tecnoteca.plonecmdbuild import plonecmdbuildMessageFactory as _
from ZTUtils import make_query
from tecnoteca.plonecmdbuild.ws.WSConst import WSConst as const

# getws
ws = context.getWS()

# read params
request = context.REQUEST
className = request.get(const.CLASSNAME)
entry = ws.getClassDetails(className)
isProcess = entry[const.ISPROCESS]
cardId = request.get(const.CARDID);
deleteCard = request.get(const.DELETECARD) == True
attachmentsCount = request.get(const.ATTACHMENTS_COUNT)

# get attr
attributes = isProcess and ws.getActivityObjects(className=className) or ws.getAttributeList(className=className, onlyBaseDSP=False);

# prepare values
attributeList = dict()
for attribute in attributes:
    attName = attribute[const.NAME]
    attValue = request.get(attribute[const.NAME])
    attType = attribute[const.TYPE]

    attributeList[attName] = attValue;

# call ws
if isProcess:
    # start process
    processId = ws.updateWorkflow(attributeList=attributeList, className=className)
    
    # attachments
    for i in range(int(attachmentsCount)):
        file = request.get(const.ATTACHMENT + str(i))
        description = request.get(const.ATTACHMENT + str(i) + const.DESCRIPTION)
        if file.filename != '':
            ws.uploadAttachment(className=className, objectid=processId, file=file.read(), filename=file.filename, category="Documento", description=description)
    
else:
    if cardId != None and int(cardId) > 0:
        if deleteCard:
            res = ws.deleteCard(className=className, cardId=cardId)
        else:
            res = ws.updateCard(cardId=cardId, attributeList=attributeList, className=className)
    else:
        res = ws.createCard(attributeList=attributeList, className=className)

# Force redirect
# Due to "ZPublisher.Conflict ConflictError" sometimes this script (that calls ws methods) 
# is called 2 or 3 times causing duplicates entry (see http://comments.gmane.org/gmane.comp.web.zope.plone.user/109874)
context.raiseRedirect(className)